﻿Type=Service
Version=6.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region

Sub Process_Globals
	Private fm As FirebaseMessaging
	Public NotificationID As Int = 1
	'LogList
	Public FMLogList As List
'	Private FMLogListMaxEntries As Int = 20	
End Sub

Sub Service_Create
   	fm.Initialize("fm")
	'Init the log list and insert a starting entry
	FMLogList.Initialize
	fm_InsertLog("Logging started", $"${Utils.IsNow}"$)
End Sub

Public Sub SubscribeToTopics
	'Topic general
	fm.SubscribeToTopic("general") 
	'Add more subscriptions
End Sub

Sub Service_Start (StartingIntent As Intent)
   If StartingIntent.IsInitialized And fm.HandleIntent(StartingIntent) Then Return
End Sub

'Handle new firebase message:
'1) create a notification (title & body) with autocancel (means the notification is removed after clicked on it)
'2) insert the msg in the loglist
'3) if the app is not paused then refresh the listview
Sub fm_MessageArrived (Message As RemoteMessage)
	Log($"FM New Message: ${Message.GetData}"$)
   	Dim n As Notification
   	n.Initialize
	n.AutoCancel = True
   	n.Icon = "icon"
	n.SetInfo2(Message.GetData.Get("title"), Message.GetData.Get("body"), "Notification_Tag", Main)
	n.Notify(NotificationID)
	fm_InsertLog(Message.GetData.Get("title"), Message.GetData.Get("body"))
	'Set the flag in the settings that a notification is unread
	Main.Settings.Put("unreadnotification", True)
End Sub

Sub Service_Destroy
	'
End Sub

#Region LOGGING
'Insert a new log entry at first position (using a helper list "LogList" with maps for each two lines row)
'Log entry holds the firebase message title (line1) and body (line2) to the listview 
'Log list has max entries
Public Sub fm_InsertLog(line1 As String, line2 As String)
	FMLogList.InsertAt(0, CreateMap("1":line1, "2":line2))
	If FMLogList.Size > Main.Settings.Get("logmaxentries") Then FMLogList.RemoveAt(FMLogList.Size - 1)
	Log($"FM Log insert ${line1} ${line2}"$)
	If Not(IsPaused(Main)) Then CallSub(Main, "RefreshLog")
End Sub
#End Region
