﻿Type=Activity
Version=6.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	Private btnCancel As Button
	Private btnSend As Button
	Private edtBody As EditText
	Private edtTitle As EditText
	Private edtTopic As EditText
	Private lblTitle As Label
	Private lblTopic As Label
	Private cbAddTimestamp As CheckBox
	Private lblTopicHint As Label
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("SendMessage")
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub btnSend_Click
	If (edtTitle.Text.Length = 0) Then
		ToastMessageShow("Title missing.", True)
		Return
	End If
	If (edtTopic.Text.Length = 0)  Then
		ToastMessageShow("Topic missing.", True)
		Return
	End If
	FirebaseSendMessage(edtTopic.Text, edtTitle.Text, edtBody.Text)
End Sub

Sub btnCancel_Click
	Activity.Finish
End Sub

#Region FIREBASE
'Send a message to firebase
Private Sub FirebaseSendMessage(Topic As String, Title As String, Body As String)
	If cbAddTimestamp.Checked Then Body = $"${Utils.IsNow}${CRLF}${Body}"$
'	ToastMessageShow($"Sending Message: ${Title}"$, False)
	Dim Job As HttpJob
	Job.Initialize("fcm", Me)
	Dim m As Map = CreateMap("to": $"/topics/${Topic}"$)
	Dim data As Map = CreateMap("title": Title, "body": Body)
	m.Put("data", data)
	Dim jg As JSONGenerator
	jg.Initialize(m)
	Job.PostString("https://fcm.googleapis.com/fcm/send", jg.ToString)
	Job.GetRequest.SetContentType("application/json;charset=UTF-8")
	Job.GetRequest.SetHeader("Authorization", "key=" & Main.API_KEY)
End Sub

Sub JobDone(job As HttpJob)
	Log("Firebase Send Message Done:" & job)
	If job.Success Then
		Log(job.GetString)
		ToastMessageShow($"Firebase Message sent."$, False)
	Else
		ToastMessageShow($"Error sending Firebase message${CRLF}${LastException.Message}"$, False)
	End If
	job.Release
	Activity.Finish
End Sub
#End Region
